SystemOrganization addCategory: #'Famix-DelphiImporter'!

MPImportCommand subclass: #FDImportDelphiProjectCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Famix-DelphiImporter'!

!FDImportDelphiProjectCommand methodsFor: 'hooks' stamp: 'DiegoLont 12/7/2012 13:32'!
execute
	| model |
	model := FDDelphiImporter import.
	model size > 0 ifTrue: [
		model install.
		self addModel: model ]
	! !

!FDImportDelphiProjectCommand methodsFor: 'hooks' stamp: 'DiegoLont 12/7/2012 13:31'!
label
	^'Import Delphi from a project file'! !

!PDProgramNode methodsFor: '*famix-delphiimporter' stamp: 'DiegoLont 11/6/2012 14:30'!
mooseModel
	^MooseModel new
		name: self programName;
		sourceLanguage: FAMIXDelphiSourceLanguage new;
		yourself! !

MooseAbstractImporter subclass: #FDDelphiImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Famix-DelphiImporter'!

!FDDelphiImporter class methodsFor: 'processing' stamp: 'DiegoLont 12/7/2012 13:52'!
addProject: aProjectName root: aFoldername
	^self new
		importProject: aProjectName root: aFoldername;
		targetModel! !

!FDDelphiImporter class methodsFor: 'processing' stamp: 'DiegoLont 11/6/2012 14:26'!
addProject: aProjectName root: aFoldername name: aName
	(PDProgramNode on: aProjectName root: aFoldername) mooseModel
		name: aName;
		install.! !

!FDDelphiImporter class methodsFor: 'processing' stamp: 'DiegoLont 12/7/2012 13:33'!
import
	^self new import! !

!FDDelphiImporter methodsFor: 'public' stamp: 'DiegoLont 12/7/2012 13:54'!
import
	(UITheme builder
		fileOpen: 'Import model from Delphi project file'
		extensions: #('dpr')) ifNotNilDo: [ :stream |
			FileDirectory splitName: stream name to: [ :dirName :filename |
				self importProject: filename root: dirName ] ].
	^self targetModel! !

!FDDelphiImporter methodsFor: 'populating' stamp: 'DiegoLont 12/7/2012 14:06'!
importProject: aProject
	self targetModel name: aProject programName.
	aProject units do: [ :unit |
		self importUnit: unit ]! !

!FDDelphiImporter methodsFor: 'public' stamp: 'DiegoLont 12/7/2012 14:04'!
importProject: aProjectName root: aFoldername
	| project |
	self setSourceLanguage.
	self importProject: (PDProgramNode on: aProjectName root: aFoldername).
	^self targetModel
	! !

!FDDelphiImporter methodsFor: 'populating' stamp: 'DiegoLont 12/7/2012 14:27'!
importUnit: aUnit
	| module |
	module := self targetModel add: (FAMIXModule new).
	module name: aUnit unitName.
	! !

!FDDelphiImporter methodsFor: 'public' stamp: 'DiegoLont 12/7/2012 13:17'!
setSourceLanguage
	self targetModel sourceLanguage: FAMIXDelphiSourceLanguage new! !
